VERSION 5.00
Object = "{3B7C8863-D78F-101B-B9B5-04021C009402}#1.2#0"; "RICHTX32.OCX"
Begin VB.UserControl ctlColour 
   ClientHeight    =   1485
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   1860
   ScaleHeight     =   1485
   ScaleWidth      =   1860
   Begin RichTextLib.RichTextBox rtfMain 
      Height          =   1455
      Left            =   0
      TabIndex        =   1
      Top             =   0
      Width           =   1815
      _ExtentX        =   3201
      _ExtentY        =   2566
      _Version        =   393217
      ScrollBars      =   3
      TextRTF         =   $"ctlColour.ctx":0000
      BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
         Name            =   "Courier New"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
   End
   Begin RichTextLib.RichTextBox rtfTemp 
      Height          =   855
      Left            =   2400
      TabIndex        =   0
      Top             =   1320
      Visible         =   0   'False
      Width           =   975
      _ExtentX        =   1720
      _ExtentY        =   1508
      _Version        =   393217
      ScrollBars      =   3
      TextRTF         =   $"ctlColour.ctx":00C8
   End
End
Attribute VB_Name = "ctlColour"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'----------------------------------------
'- Name: Sam Huggill
'- Email: sam@vbsquare.com
'- Web: http://www.vbsquare.com/
'- Company: Lighthouse Internet Solutions
'- Date/Time: 14/08/99 11:26:38
'----------------------------------------
'- Notes:   Automatically colourizes code
'           Written by James Crowley -
'           www.vbweb.f9.co.uk
'----------------------------------------

Option Explicit

Private m_ColourComment As OLE_COLOR
Private m_ColourKeyword As OLE_COLOR
Private m_ColourText As OLE_COLOR

Private m_strBlackKeywords As String
Private m_strBlueKeywords As String

Private m_intSelPos As Integer
Private m_intSelLen As Integer
Private m_blnBusy As Boolean
Private m_blnChanged As Boolean

Private m_intNextLine As Integer
Private m_intLastLine As Integer
Private m_intLastLinePos As Integer

'Default Property Values:
Const m_def_AutoVerbMenu = 0
Const m_def_BulletIndent = 0
Const m_def_DisableNoScroll = 0
Const m_def_FileName = ""
Const m_def_Locked = 0
Const m_def_MultiLine = 0
Const m_def_OLEDragMode = 0
Const m_def_RightMargin = 0
Const m_def_ScrollBars = 0
Const m_def_Text = ""
Const m_def_ToolTipText = ""
Const m_def_ColourComment = 0
Const m_def_ColourKeyword = 0
Const m_def_ColourText = 0
'Property Variables:
Dim m_AutoVerbMenu As Boolean
Dim m_BulletIndent As Single
Dim m_DisableNoScroll As Boolean
Dim m_FileName As String
Dim m_Locked As Boolean
Dim m_MultiLine As Boolean
Dim m_OLEDragMode As OLEDragConstants
Dim m_RightMargin As Single
Dim m_ScrollBars As ScrollBarsConstants
Dim m_Text As String
Dim m_ToolTipText As String
Dim m_blnColour As Boolean
'Event Declarations:
Event Change()
Event Click()
Event DblClick()
Event OLECompleteDrag(Effect As Long)
Event OLEDragDrop(Data As RichTextLib.DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single)
Event OLEDragOver(Data As RichTextLib.DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single, State As Integer)
Event OLEGiveFeedback(Effect As Long, DefaultCursors As Boolean)
Event OLESetData(Data As RichTextLib.DataObject, DataFormat As Integer)
Event OLEStartDrag(Data As RichTextLib.DataObject, AllowedEffects As Long)
Event KeyDown(KeyCode As Integer, Shift As Integer) 'MappingInfo=UserControl,UserControl,-1,KeyDown
Event KeyPress(KeyAscii As Integer) 'MappingInfo=UserControl,UserControl,-1,KeyPress
Event KeyUp(KeyCode As Integer, Shift As Integer) 'MappingInfo=UserControl,UserControl,-1,KeyUp
Event MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single) 'MappingInfo=UserControl,UserControl,-1,MouseDown
Event MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single) 'MappingInfo=UserControl,UserControl,-1,MouseMove
Event MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single) 'MappingInfo=UserControl,UserControl,-1,MouseUp
Event SelChange()


Public Property Get Font() As Font
    Set Font = rtfMain.Font
End Property

Public Property Set Font(ByVal New_Font As Font)
    Set rtfMain.Font = New_Font
    Set rtfTemp.Font = New_Font
    PropertyChanged "Font"
End Property

Public Property Get ColourComment() As OLE_COLOR
    ColourComment = m_ColourComment
End Property

Public Property Let ColourComment(ByVal New_ColourComment As OLE_COLOR)
    m_ColourComment = New_ColourComment
    PropertyChanged "ColourComment"
End Property

Public Property Get ColourKeyword() As OLE_COLOR
    ColourKeyword = m_ColourKeyword
End Property

Public Property Let ColourKeyword(ByVal New_ColourKeyword As OLE_COLOR)
    m_ColourKeyword = New_ColourKeyword
    PropertyChanged "ColourKeyword"
End Property

Public Property Get ColourText() As OLE_COLOR
    ColourText = m_ColourText
End Property

Public Property Let ColourText(ByVal New_ColourText As OLE_COLOR)
    m_ColourText = New_ColourText
    PropertyChanged "ColourText"
End Property

Public Sub Initalize()
    '// Initalize the words that need to be coloured
    m_strBlackKeywords = "*Abs*Add*AddItem*AppActivate*Array*Asc*Atn*Beep*Begin*BeginProperty*ChDir*ChDrive*Choose*Chr*Clear*Collection*Command*Cos*CreateObject*CurDir*DateAdd*DateDiff*DatePart*DateSerial*DateValue*Day*DDB*DeleteSetting*Dir*DoEvents*EndProperty*Environ*EOF*Err*Exp*FileAttr*FileCopy*FileDateTime*FileLen*Fix*Format*FV*GetAllSettings*GetAttr*GetObject*GetSetting*Hex*Hide*Hour*InputBox*InStr*Int*Int*IPmt*IRR*IsArray*IsDate*IsEmpty*IsError*IsMissing*IsNull*IsNumeric*IsObject*Item*Kill*LCase*Left*Len*Load*Loc*LOF*Log*LTrim*Me*Mid*Minute*MIRR*MkDir*Month*Now*NPer*NPV*Oct*Pmt*PPmt*PV*QBColor*Raise*Randomize*Rate*Remove*RemoveItem*Reset*RGB*Right*RmDir*Rnd*RTrim*SaveSetting*Second*SendKeys*SetAttr*Sgn*Shell*Sin*Sin*SLN*Space*Sqr*Str*StrComp*StrConv*Switch*SYD*Tan*Text*Time*Time*Timer*TimeSerial*TimeValue*Trim*TypeName*UCase*Unload*Val*VarType*WeekDay*Width*Year*"
    m_strBlueKeywords = "*#Const*#Else*#ElseIf*#End If*#If*Alias*Alias*And*As*Base*Binary*Boolean*Byte*ByVal*Call*Case*CBool*CByte*CCur*CDate*CDbl*CDec*CInt*CLng*Close*Compare*Const*CSng*CStr*Currency*CVar*CVErr*Decimal*Declare*DefBool*DefByte*DefCur*DefDate*DefDbl*DefDec*DefInt*DefLng*DefObj*DefSng*DefStr*DefVar*Dim*Do*Double*Each*Else*ElseIf*End*Enum*Eqv*Erase*Error*Exit*Explicit*False*For*Function*Get*Global*GoSub*GoTo*If*Imp*In*Input*Input*Integer*Is*LBound*Let*Lib*Like*Line*Lock*Long*Loop*LSet*Name*New*Next*Not*Object*On*Open*Option*Or*Output*Print*Private*Property*Public*Put*Random*Read*ReDim*Resume*Return*RSet*Seek*Select*Set*Single*Spc*Static*String*Stop*Sub*Tab*Then*Then*True*Type*UBound*Unlock*Variant*Wend*While*With*Xor*Nothing*To*"
End Sub

Public Sub Colour(rtf As Object, blnAll As Boolean)

    Dim strText As String
    Dim intSelLen As Long

    If blnAll = True Then
        '// If we want to colour the whole thing,
        '// go to the end
        rtfTemp.TextRTF = rtf.TextRTF
        GoTo TheRest
    End If
    '// Copy the text into our tempory text box, colour it and
    '// return the text to the original text box

    strText = GetLineText(rtf)
    If strText = "-1" Then
        Exit Sub
    End If
    rtfTemp.Text = strText

TheRest:
    '// Delete the line
    If rtf.SelText Like "vbcrlf*" Then
        intSelLen = rtf.SelLength
        rtf.SelStart = rtf.SelStart + 2
        rtf.SelLength = intSelLen - 2
    ElseIf rtf.SelText Like "*vbcrlf" Then
        rtf.SelLength = rtf.SelLength - 2
    End If
    rtf.SelText = ""
    If rtfTemp.Text = "" Then
        Exit Sub
    End If
    Call Initalize

    ColorizeWords
    DoEvents

    If blnAll = True Then
        '// Update the whole text box
        rtfTemp.SelStart = 0
        rtfTemp.SelLength = Len(rtfTemp.Text)
        rtf.TextRTF = rtfTemp.SelRTF
    Else
        If rtfTemp.Text = "" Then
            rtf.SelRTF = ""
        Else
            rtf.SelLength = 0

            rtfTemp.SelStart = 0
            rtfTemp.SelLength = Len(rtfTemp.Text)
            rtf.SelRTF = rtfTemp.SelRTF
        End If
    End If
    '// Allow redrawing and refresh it
    SendMessage rtfMain.hwnd, WM_SETREDRAW, True, 0&
    rtfMain.Refresh
End Sub
Public Sub AboutBox()
    '// Shows our about box
    MsgBox "Copyright 1999 VB Square - http://www.programmerz.com/vb/" & Chr(13) & "    Written By Sam Huggill of Lighthouse Internet Solutions"

End Sub
Private Sub rtfMain_Change()
    m_blnChanged = True
    RaiseEvent Change
End Sub

Private Sub rtfMain_Click()
    RaiseEvent Click
End Sub

Private Sub rtfMain_DblClick()
    RaiseEvent DblClick
End Sub


Private Sub rtfMain_GotFocus()
    m_blnChanged = True
End Sub

Private Sub rtfMain_KeyDown(KeyCode As Integer, Shift As Integer)
    If m_blnColour = False Then Exit Sub
    If KeyCode = vbKeyV And Shift = vbCtrlMask Then
        '// If the data on the clipboard is text,
        '// then colour it before putting into the
        '// text box
        If Clipboard.GetFormat(vbCFText) Then
            PasteCode
        End If
        KeyCode = 0
    End If
    RaiseEvent KeyDown(KeyCode, Shift)
End Sub

Private Sub rtfMain_KeyPress(KeyAscii As Integer)
    RaiseEvent KeyPress(KeyAscii)
End Sub

Private Sub rtfMain_KeyUp(KeyCode As Integer, Shift As Integer)
    RaiseEvent KeyUp(KeyCode, Shift)
End Sub

Private Sub rtfMain_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent MouseDown(Button, Shift, X, Y)
End Sub

Private Sub rtfMain_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent MouseMove(Button, Shift, X, Y)
End Sub

Private Sub rtfMain_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent MouseUp(Button, Shift, X, Y)
End Sub

Private Sub rtfMain_OLECompleteDrag(Effect As Long)
    RaiseEvent OLECompleteDrag(Effect)
End Sub

Private Sub rtfMain_OLEDragDrop(Data As RichTextLib.DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent OLEDragDrop(Data, Effect, Button, Shift, X, Y)
End Sub

Private Sub rtfMain_OLEDragOver(Data As RichTextLib.DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single, State As Integer)
    RaiseEvent OLEDragOver(Data, Effect, Button, Shift, X, Y, State)
End Sub

Private Sub rtfMain_OLEGiveFeedback(Effect As Long, DefaultCursors As Boolean)
    RaiseEvent OLEGiveFeedback(Effect, DefaultCursors)
End Sub

Private Sub rtfMain_OLESetData(Data As RichTextLib.DataObject, DataFormat As Integer)
    RaiseEvent OLESetData(Data, DataFormat)
End Sub

Private Sub rtfMain_OLEStartDrag(Data As RichTextLib.DataObject, AllowedEffects As Long)
    RaiseEvent OLEStartDrag(Data, AllowedEffects)
End Sub

Private Sub rtfMain_SelChange()
    Static blnMoved As Boolean
    If m_blnColour = False Then Exit Sub
    If m_blnBusy = False Then
        '// Save current position
        m_intSelPos = rtfMain.SelStart
        m_intSelLen = rtfMain.SelLength
    Else
        Exit Sub
    End If
    If m_blnChanged = False Then
        m_intLastLine = SendMessage(rtfMain.hwnd, EM_LINEFROMCHAR, rtfMain.SelStart + rtfMain.SelLength, 0&)
        m_intLastLinePos = rtfMain.SelStart + rtfMain.SelLength
        Exit Sub
    End If
    m_blnBusy = True

    If Not SendMessage(rtfMain.hwnd, EM_LINEFROMCHAR, m_intLastLinePos, 0&) = SendMessage(rtfMain.hwnd, EM_LINEFROMCHAR, rtfMain.SelStart + rtfMain.SelLength, 0&) Then
        SendMessage rtfMain.hwnd, WM_SETREDRAW, False, 0&
        '// Go back to the last line we were on
        rtfMain.SelStart = m_intLastLinePos
        rtfMain.SelLength = 0
        DoEvents
        '// Colour it
        ColourDoc False
        SendMessage rtfMain.hwnd, WM_SETREDRAW, True, 0&
    End If
    m_intLastLine = SendMessage(rtfMain.hwnd, EM_LINEFROMCHAR, rtfMain.SelStart + rtfMain.SelLength, 0&)
    m_intLastLinePos = rtfMain.SelStart + rtfMain.SelLength
    m_blnBusy = False
    m_blnChanged = False

End Sub

'Initialize Properties for User Control
Private Sub UserControl_InitProperties()
    Set Font = Ambient.Font
    Set Font = Ambient.Font
    m_AutoVerbMenu = m_def_AutoVerbMenu
    m_BulletIndent = m_def_BulletIndent
    m_DisableNoScroll = m_def_DisableNoScroll
    m_FileName = m_def_FileName
    m_Locked = m_def_Locked
    m_MultiLine = m_def_MultiLine
    m_OLEDragMode = m_def_OLEDragMode
    m_RightMargin = m_def_RightMargin
    m_ScrollBars = rtfBoth
    m_Text = m_def_Text
    m_ToolTipText = m_def_ToolTipText
    m_ColourComment = m_def_ColourComment
    m_ColourKeyword = m_def_ColourKeyword
    m_ColourText = m_def_ColourText
    m_blnColour = True
End Sub

'Load property values from storage
Private Sub UserControl_ReadProperties(PropBag As PropertyBag)

    Set Font = PropBag.ReadProperty("Font", Ambient.Font)
    Set Font = PropBag.ReadProperty("Font", Ambient.Font)
    m_AutoVerbMenu = PropBag.ReadProperty("AutoVerbMenu", m_def_AutoVerbMenu)
    rtfMain.BackColor = PropBag.ReadProperty("BackColor", &H8000000F)
    rtfMain.BorderStyle = PropBag.ReadProperty("BorderStyle", 0)
    m_BulletIndent = PropBag.ReadProperty("BulletIndent", m_def_BulletIndent)
    m_DisableNoScroll = PropBag.ReadProperty("DisableNoScroll", m_def_DisableNoScroll)
    rtfMain.Enabled = PropBag.ReadProperty("Enabled", True)
    m_FileName = PropBag.ReadProperty("FileName", m_def_FileName)
    m_Locked = PropBag.ReadProperty("Locked", m_def_Locked)
    Set MouseIcon = PropBag.ReadProperty("MouseIcon", Nothing)
    m_MultiLine = PropBag.ReadProperty("MultiLine", m_def_MultiLine)
    m_OLEDragMode = PropBag.ReadProperty("OLEDragMode", m_def_OLEDragMode)
    rtfMain.OLEDropMode = PropBag.ReadProperty("OLEDropMode", 0)
    m_RightMargin = PropBag.ReadProperty("RightMargin", m_def_RightMargin)
    m_ScrollBars = PropBag.ReadProperty("ScrollBars", m_def_ScrollBars)
    m_Text = PropBag.ReadProperty("Text", m_def_Text)
    m_ToolTipText = PropBag.ReadProperty("ToolTipText", m_def_ToolTipText)
    m_ColourComment = PropBag.ReadProperty("ColourComment", m_def_ColourComment)
    m_ColourKeyword = PropBag.ReadProperty("ColourKeyword", m_def_ColourKeyword)
    m_ColourText = PropBag.ReadProperty("ColourText", m_def_ColourText)
    rtfMain.TextRTF = PropBag.ReadProperty("TextRTF", "")
    rtfMain.TabStop = PropBag.ReadProperty("TabStop", False)
    m_blnColour = PropBag.ReadProperty("ColourOn", True)
End Sub

Private Sub UserControl_Resize()
    rtfMain.Width = UserControl.Width
    rtfMain.Height = UserControl.Height
End Sub

'Write property values to storage
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)

    Call PropBag.WriteProperty("Font", Font, Ambient.Font)
    Call PropBag.WriteProperty("Font", Font, Ambient.Font)
    Call PropBag.WriteProperty("AutoVerbMenu", m_AutoVerbMenu, m_def_AutoVerbMenu)
    Call PropBag.WriteProperty("BackColor", rtfMain.BackColor, &H8000000F)
    Call PropBag.WriteProperty("BorderStyle", rtfMain.BorderStyle, 0)
    Call PropBag.WriteProperty("BulletIndent", m_BulletIndent, m_def_BulletIndent)
    Call PropBag.WriteProperty("DisableNoScroll", m_DisableNoScroll, m_def_DisableNoScroll)
    Call PropBag.WriteProperty("Enabled", rtfMain.Enabled, True)
    Call PropBag.WriteProperty("FileName", m_FileName, m_def_FileName)
    Call PropBag.WriteProperty("Locked", m_Locked, m_def_Locked)
    Call PropBag.WriteProperty("MouseIcon", MouseIcon, Nothing)
    Call PropBag.WriteProperty("MultiLine", m_MultiLine, m_def_MultiLine)
    Call PropBag.WriteProperty("OLEDragMode", m_OLEDragMode, m_def_OLEDragMode)
    Call PropBag.WriteProperty("OLEDropMode", rtfMain.OLEDropMode, 0)
    Call PropBag.WriteProperty("RightMargin", m_RightMargin, m_def_RightMargin)
    Call PropBag.WriteProperty("ScrollBars", m_ScrollBars, m_def_ScrollBars)
    Call PropBag.WriteProperty("Text", m_Text, m_def_Text)
    Call PropBag.WriteProperty("ToolTipText", m_ToolTipText, m_def_ToolTipText)
    Call PropBag.WriteProperty("ColourComment", m_ColourComment, m_def_ColourComment)
    Call PropBag.WriteProperty("ColourKeyword", m_ColourKeyword, m_def_ColourKeyword)
    Call PropBag.WriteProperty("ColourText", m_ColourText, m_def_ColourText)
    Call PropBag.WriteProperty("TextRTF", rtfMain.TextRTF, "")
    Call PropBag.WriteProperty("TabStop", rtfMain.TabStop, False)
    Call PropBag.WriteProperty("ColourOn", m_blnColour, True)
End Sub

Private Sub ColorizeWords()
    Dim sBuffer    As String
    Dim i          As Long
    Dim nJ         As Long
    Dim sTmpWord   As String
    Dim nStartPos  As Long
    Dim nSelLen    As Long
    Dim nWordPos   As Long
    Dim clsWait As CWaitCursor

    '// Set the cursor to wait
    Set clsWait = New CWaitCursor

    clsWait.SetCursor

    '// Apply the font and colour styles
    rtfTemp.SelStart = 0
    rtfTemp.SelLength = Len(rtfTemp.Text)
    rtfTemp.SelColor = m_ColourText
    rtfTemp.SelFontName = rtfMain.Font
    rtfTemp.SelFontSize = rtfMain.Font.Size

    '// Loop through every character in the text and check
    '// for different letters and characters
    '// Solves a small bug that doesn't colour a word
    '// if it does not have a space after it
    sBuffer = rtfTemp.Text & " "
    sTmpWord = ""

    For i = 1 To Len(sBuffer)
        frmMain.pgb.Value = (i / (Len(sBuffer) + 1)) * 100
        Select Case mID(sBuffer, i, 1)
            Case "A" To "Z", "a" To "z", "_"

                If sTmpWord = "" Then nStartPos = i
                sTmpWord = sTmpWord & mID(sBuffer, i, 1)

            Case Chr(34)

                nSelLen = 1

                For nJ = 1 To 9999999

                    If mID(sBuffer, i + 1, 1) = Chr(34) Then
                        i = i + 2
                        Exit For
                    Else
                        nSelLen = nSelLen + 1
                        i = i + 1
                    End If

                Next

            Case Chr(39)
                rtfTemp.SelStart = i - 1
                nSelLen = 0

                For nJ = 1 To 9999999

                    If mID(sBuffer, i, 2) = vbCrLf Then
                        Exit For
                    Else
                        nSelLen = nSelLen + 1
                        i = i + 1
                        If nSelLen > Len(sBuffer) Then Exit For
                    End If

                Next

                rtfTemp.SelLength = nSelLen
                rtfTemp.SelColor = m_ColourComment

            Case Else
                If Trim(sTmpWord) <> "" Then
                    rtfTemp.SelStart = nStartPos - 1
                    rtfTemp.SelLength = Len(sTmpWord)
                    nWordPos = InStr(1, m_strBlackKeywords, "*" & sTmpWord & "*", 1)
                    If nWordPos <> 0 Then
                        rtfTemp.SelColor = m_ColourText
                        rtfTemp.SelText = mID(m_strBlackKeywords, nWordPos + 1, Len(sTmpWord))
                    End If

                    nWordPos = InStr(1, m_strBlueKeywords, "*" & sTmpWord & "*", 1)

                    If nWordPos <> 0 Then
                        rtfTemp.SelColor = m_ColourKeyword
                        rtfTemp.SelText = mID(m_strBlueKeywords, nWordPos + 1, Len(sTmpWord))
                    End If

                    If UCase(sTmpWord) = "REM" Then
                        rtfTemp.SelStart = i - 4
                        rtfTemp.SelLength = 3

                        For nJ = 1 To 9999999
                            If mID(sBuffer, i, 2) = vbCrLf Then
                                Exit For
                            Else
                                rtfTemp.SelLength = rtfTemp.SelLength + 1
                                i = i + 1
                            End If
                        Next

                        rtfTemp.SelColor = m_ColourKeyword
                        rtfTemp.SelText = LCase(rtfTemp.SelText)

                    End If
                End If

                sTmpWord = ""
        End Select
    Next
    rtfTemp.SelStart = 0
    frmMain.pgb.Value = 0
End Sub

Private Sub ColourDoc(blnAll As Boolean, Optional blnBlack As Boolean)
    rtfMain.Locked = True
    Colour rtfMain, blnAll
    '// Restore positions
    rtfMain.SelStart = m_intSelPos
    rtfMain.SelLength = m_intSelLen
    rtfMain.Locked = False
    m_blnChanged = False
    m_intNextLine = 1
End Sub

Private Sub ColourLineBlack(rtf As RichTextBox)
    Dim strText As String
    Dim intSelLen As Long
    '// Copy the text into our tempory text box, colour it and
    '// return the text to the original text box
    strText = GetLineText(rtf)
    If strText = "-1" Then
        Exit Sub
    End If
    rtfTemp.Text = strText
TheRest:
    '// Delete the line
    If rtf.SelText Like "vbcrlf*" Then
        intSelLen = rtf.SelLength
        rtf.SelStart = rtf.SelStart + 2
        rtf.SelLength = intSelLen - 2
    ElseIf rtf.SelText Like "*vbcrlf" Then
        rtf.SelLength = rtf.SelLength - 2
    End If

    rtf.SelRTF = ""
    rtfTemp.SelStart = 0
    rtfTemp.SelLength = Len(rtfTemp.Text)
    rtfTemp.SelColor = vbBlack
    If rtfTemp.Text = "" Then
        Exit Sub
    End If
    DoEvents
    If Not rtfTemp.Text = "" Then
        rtf.SelRTF = rtfTemp.SelRTF
    End If
    '// Allow redrawing and refresh the contents
    SendMessage rtfMain.hwnd, WM_SETREDRAW, True, 0&
    rtfMain.Refresh
End Sub

Private Function GetLineText(rtf As Object) As String
    Dim intCurrLine As Integer
    Dim intStartPos As Integer
    Dim intEndLen As Integer
    Dim intSelLen As Integer
    Dim strSearch As String

    rtf.SelLength = 0
    '// Get current line
    intCurrLine = SendMessage(rtf.hwnd, EM_LINEFROMCHAR, rtf.SelStart + rtf.SelLength, 0&)
    '// Set the start pos at the beginning of the line
    rtf.SelStart = SendMessage(rtf.hwnd, EM_LINEINDEX, intCurrLine, 0&)
    If Err Then
        '// Line does not exist
        GetLineText = -1
        Exit Function
    End If

FindEndofLine:
    '// Get the length of the line
    intSelLen = SendMessage(rtf.hwnd, EM_LINELENGTH, rtf.SelStart + rtf.SelLength, 0&)
    '// Select the line
    rtf.SelLength = intSelLen
    GetLineText = rtf.SelText
End Function

Public Sub PasteCode()
    m_blnBusy = True
    '// Get the clipboard data
    If Clipboard.GetFormat(vbCFText) = False Then
        '// Not text, get out of here
        Exit Sub
    End If
    SendMessage rtfMain.hwnd, WM_SETREDRAW, False, 0&
    '// Clear the text
    rtfMain.SelText = ""
    '// Get the clipboard text
    rtfTemp.TextRTF = Clipboard.GetText
    '// Lock the text box to prevent changes
    rtfMain.Locked = True
    '// Save the selstart
    m_intSelPos = rtfMain.SelStart
    '// colour the whole lot in the temp box
    Initalize
    Colour rtfTemp, True
    '// Make sure the temp box is not visible
    rtfTemp.Visible = False
    '// Restore the sel start
    rtfMain.SelStart = m_intSelPos
    '// Highlight the text, except the last return
    rtfTemp.SelStart = 0
    rtfTemp.SelLength = Len(rtfTemp.Text)
    '// Return the text
    rtfMain.SelRTF = rtfTemp.SelRTF
    '// We are not busy
    m_blnBusy = False
    '// Allow changes again
    rtfMain.Locked = False
    m_blnChanged = False
    '// Get the new line pos
    m_intLastLine = SendMessage(rtfMain.hwnd, EM_LINEFROMCHAR, rtfMain.SelStart + rtfMain.SelLength, 0&)
    m_intLastLinePos = rtfMain.SelStart + rtfMain.SelLength
    '// Allow redrawing and refresh the contents
    SendMessage rtfMain.hwnd, WM_SETREDRAW, True, 0&
    rtfMain.Refresh
End Sub
'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,Font

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,Appearance
Public Property Get Appearance() As Integer
    Appearance = rtfMain.Appearance
End Property

Public Property Get AutoVerbMenu() As Boolean
    AutoVerbMenu = rtfMain.Appearance
End Property

Public Property Let AutoVerbMenu(ByVal New_AutoVerbMenu As Boolean)
    rtfMain.AutoVerbMenu = New_AutoVerbMenu
    PropertyChanged "AutoVerbMenu"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,BackColor
Public Property Get BackColor() As OLE_COLOR
    BackColor = rtfMain.BackColor
End Property

Public Property Let BackColor(ByVal New_BackColor As OLE_COLOR)
    rtfMain.BackColor() = New_BackColor
    PropertyChanged "BackColor"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,BorderStyle
Public Property Get BorderStyle() As Integer
    BorderStyle = rtfMain.BorderStyle
End Property

Public Property Let BorderStyle(ByVal New_BorderStyle As Integer)
    rtfMain.BorderStyle() = New_BorderStyle
    PropertyChanged "BorderStyle"
End Property

Public Property Get BulletIndent() As Single
    BulletIndent = rtfMain.BulletIndent
End Property

Public Property Let BulletIndent(ByVal New_BulletIndent As Single)
    rtfMain.BulletIndent = New_BulletIndent
    PropertyChanged "BulletIndent"
End Property

Public Property Get DisableNoScroll() As Boolean
    DisableNoScroll = rtfMain.DisableNoScroll
End Property

Public Property Let DisableNoScroll(ByVal New_DisableNoScroll As Boolean)
    rtfMain.DisableNoScroll = New_DisableNoScroll
    PropertyChanged "DisableNoScroll"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,Enabled
Public Property Get Enabled() As Boolean
    Enabled = UserControl.Enabled
End Property

Public Property Let Enabled(ByVal New_Enabled As Boolean)
    UserControl.Enabled() = New_Enabled
    PropertyChanged "Enabled"
End Property

Public Property Get FileName() As String
    FileName = rtfMain.FileName
End Property

Public Property Let FileName(ByVal New_FileName As String)
    rtfMain.FileName = New_FileName
    PropertyChanged "FileName"
End Property

Public Function Find(bstrString As String, Optional vStart As Variant, Optional vEnd As Variant, Optional vOptions As Variant) As Long

End Function

Public Property Get Locked() As Boolean
    Locked = rtfMain.Locked
End Property

Public Property Let Locked(ByVal New_Locked As Boolean)
    rtfMain.Locked = New_Locked
    PropertyChanged "Locked"
End Property


'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=rtfMain,rtfMain,-1,MouseIcon
Public Property Get MouseIcon() As Picture
    Set MouseIcon = rtfMain.MouseIcon
End Property

Public Property Set MouseIcon(ByVal New_MouseIcon As Picture)
    Set rtfMain.MouseIcon = New_MouseIcon
    PropertyChanged "MouseIcon"
End Property

Public Property Get MultiLine() As Boolean
    MultiLine = rtfMain.MultiLine
End Property

Public Property Let MultiLine(ByVal New_MultiLine As Boolean)
    rtfMain.MultiLine = New_MultiLine
    PropertyChanged "MultiLine"
End Property

Public Property Get OLEDragMode() As OLEDragConstants
    OLEDragMode = rtfMain.OLEDragMode
End Property

Public Property Let OLEDragMode(ByVal New_OLEDragMode As OLEDragConstants)
    rtfMain.OLEDragMode = New_OLEDragMode
    PropertyChanged "OLEDragMode"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=rtfMain,rtfMain,-1,OLEDropMode
Public Property Get OLEDropMode() As Integer
    OLEDropMode = rtfMain.OLEDropMode
End Property

Public Property Let OLEDropMode(ByVal New_OLEDropMode As Integer)
    rtfMain.OLEDropMode() = New_OLEDropMode
    PropertyChanged "OLEDropMode"
End Property

Public Property Get RightMargin() As Single
    RightMargin = rtfMain.RightMargin
End Property

Public Property Let RightMargin(ByVal New_RightMargin As Single)
    rtfMain.RightMargin = New_RightMargin
    PropertyChanged "RightMargin"
End Property

Public Property Get ScrollBars() As ScrollBarsConstants
    ScrollBars = rtfMain.ScrollBars
End Property

Public Property Let ScrollBars(ByVal New_ScrollBars As ScrollBarsConstants)
    rtfMain.ScrollBars = New_ScrollBars
    PropertyChanged "ScrollBars"
End Property


Public Property Get Text() As String
    Text = rtfMain.Text
End Property

Public Property Let Text(ByVal New_Text As String)
    rtfMain.Text = New_Text
    PropertyChanged "Text"
End Property

Public Property Get ToolTipText() As String
    ToolTipText = rtfMain.ToolTipText
End Property

Public Property Let ToolTipText(ByVal New_ToolTipText As String)
    rtfMain.ToolTipText = New_ToolTipText
    PropertyChanged "ToolTipText"
End Property

Public Property Get TextRTF() As String
    TextRTF = rtfMain.TextRTF
End Property

Public Property Let TextRTF(ByVal New_Text As String)
    rtfMain.TextRTF = New_Text
    PropertyChanged "TextRTF"
End Property

Public Property Get TabStop() As Boolean
    TabStop = rtfMain.TabStop
End Property

Public Property Let TabStop(ByVal New_Tab As Boolean)
    rtfMain.TabStop = New_Tab
    PropertyChanged "TabStop"
End Property

Public Property Get ColourOn() As Boolean
    ColourOn = m_blnColour
End Property

Public Property Let ColourOn(ByVal New_ColourOn As Boolean)
    m_blnColour = New_ColourOn
    PropertyChanged "ColourOn"
End Property

Public Property Get SelLength() As Long
    SelLength = rtfMain.SelLength
End Property

Public Property Let SelLength(ByVal New_Len As Long)
    rtfMain.SelLength = New_Len
End Property

Public Property Get SelStart() As Long
    SelStart = rtfMain.SelStart
End Property

Public Property Let SelStart(ByVal New_Start As Long)
    rtfMain.SelStart = New_Start
End Property

Public Property Let SelText(ByVal New_Sel As String)
    rtfMain.SelText = New_Sel
End Property

Public Property Get SelText() As String
    SelText = rtfMain.SelText
End Property

Public Property Let SelRTF(ByVal NewText As String)
    rtfMain.SelRTF = NewText
End Property

Public Property Get SelRTF() As String
    SelRTF = rtfMain.SelRTF
End Property
Public Property Get hwnd() As Long
    hwnd = rtfMain.hwnd
End Property

' Printing code by Jeffj
Public Function SelPrint(lHDC As Long, comd As CommonDialog, Optional vStartDoc As Variant) As String
    On Local Error GoTo error_handler:

    With comd
        .CancelError = True
        .flags = cdlPDReturnDC + cdlPDNoPageNums

        If rtfMain.SelLength = 0 Then
            .flags = .flags + cdlPDAllPages
        Else
            .flags = .flags + cdlPDSelection
        End If

        .ShowPrinter
        On Local Error Resume Next
        Printer.Print ""
        rtfMain.SelPrint Printer.hdc
        Printer.EndDoc
        ' FilePrintDlgProc = True
    End With

    Exit Function
error_handler:

    If Err <> cdlCancel Then
        MsgBox "Error " & Err & "; " & Error
    End If

End Function

